include "ZeroPage.inc"

tempo equ 180*2

dseg
SoundProc_: public SoundProc_
    defw 0

cseg

InitSound_: public InitSound_
    lda #0
    sta SoundProc_
    sta SoundProc_+1
rts

CallSound:
    jmp (SoundProc_)

CallSound_: public CallSound_
    lda SoundProc_
    ora SoundProc_+1
    if ne
        jsr CallSound
        lda #0
        sta SoundProc_
        sta SoundProc_+1
    endif
rts



Tone:
;   <ZB3: length
;   <ZB0: cycle
    do
        lda #$04 | sta $b002
        lda <ZB0
        sta <ZB4
        do
            nop | nop | nop | nop | nop | nop
            dec <ZB4
        while ne | wend
        lda #$00 | sta $b002
        lda <ZB0
        sta <ZB4
        do
            nop | nop | nop | nop | nop | nop
            dec <ZB4
        while ne | wend
        dec <ZB3
    while ne | wend
rts


Rest:
;   <ZB3: length
;   <ZB0: cycle
    do
        lda SoundProc_
        lda <ZB0
        sta <ZB4
        do
            nop | nop | nop | nop | nop | nop
            dec <ZB4
        while ne | wend
        lda SoundProc_
        lda <ZB0
        sta <ZB4
        do
            nop | nop | nop | nop | nop | nop
            dec <ZB4
        while ne | wend
        dec <ZB3
    while ne | wend
rts

Sound_Fire_: public Sound_Fire_
    lda #60 | sta <ZB0
    lda #9 | sta <ZB3
    jsr Tone
rts


Sound_Hit:
    ldx #150
    do
        stx <ZB0
        lda #1 | sta <ZB3
        jsr Tone
        dex
        cpx #70
    while ne | wend
rts

Sound_Hit_: public Sound_Hit_
    lda #low Sound_Hit | sta SoundProc_
    lda #high Sound_Hit | sta SoundProc_+1
rts


Sound_Loose:
    ldx #70
    do
        stx <ZB0
        lda #1 | sta <ZB3
        jsr Tone
        inx
        cpx #100
    while ne | wend
rts

Sound_Loose_: public Sound_Loose_
    lda #low Sound_Loose | sta SoundProc_
    lda #high Sound_Loose | sta SoundProc_+1
rts


Melody:
    ldy #0
    do
        lda (<ZW2),y
    while ne
        sta <ZB1

        iny
        lda (<ZW2),y
        iny
        
        cmp #0
        if ne
            sec | sbc #1
            asl a
            tax
            lda cycles,x
            sta <ZB0
            inx 
            do
                lda cycles,x | sta <ZB3
                jsr Tone
                dec <ZB1
            while ne | wend
        else
            asl a
            tax
            lda cycles,x
            sta <ZB0
            inx 
            do
                lda cycles,x | sta <ZB3
                jsr Rest
                dec <ZB1
            while ne | wend
        endif
    wend
rts


C4 equ 1
C4S equ 2
D4 equ 3
D4S equ 4
E4 equ 5
F4 equ 6
F4S equ 7
G4 equ 8
G4S equ 9
A4 equ 10
A4S equ 11
B4 equ 12
C5 equ 13
C5S equ 14
D5 equ 15
D5S equ 16
E5 equ 17
F5 equ 18


start_notes: 
    defb 11,A4,1,0, 11,A4,1,0
	defb 5,A4,1,0, 11,C5,1,0, 5,D5,1,0
	defb 23,E5,1,0
	defb 12,0, 12,0
    defb 0
Sound_Start_: public Sound_Start_
    lda #low start_notes | sta <ZW2
    lda #high start_notes | sta <ZW2+1
jmp Melody


clear_notes: 
    defb 5,A4,1,0, 6,0, 5,A4,1,0, 5,G4,1,0
	defb 5,A4,1,0, 11,C5,1,0, 5,D5,1,0
	defb 6,0, 5,C5,1,0, 6,0, 17,A4,1,0
	defb 24,0
    defb 0
Sound_Clear_: public Sound_Clear_
    lda #low clear_notes | sta <ZW2
    lda #high clear_notes | sta <ZW2+1
jmp Melody


over_notes: 
	defb 5,A4,1,0, 5,E5,1,0, 5,D5,1,0, 5,C5,1,0
	defb 5,D5,1,0, 5,C5,1,0, 5,B4,1,0, 17,A4,1,0
	defb 6,0, 11,G4,1,0, 5,G4,1,0
	defb 11,A4,1,0
    defb 0
Sound_GameOver_: public Sound_GameOver_
    lda #low over_notes | sta <ZW2
    lda #high over_notes | sta <ZW2+1
jmp Melody


cycles:
defb 100,(10000000/tempo-10)/(3820+16) ; C4
defb 94,(10000000/tempo-10)/(3592+16) ; C4S
defb 89,(10000000/tempo-10)/(3402+16) ; D4
defb 84,(10000000/tempo-10)/(3212+16) ; D4S
defb 79,(10000000/tempo-10)/(3022+16) ; E4
defb 74,(10000000/tempo-10)/(2832+16) ; F4
defb 70,(10000000/tempo-10)/(2680+16) ; F4S
defb 66,(10000000/tempo-10)/(2528+16) ; G4
defb 62,(10000000/tempo-10)/(2376+16) ; G4S
defb 59,(10000000/tempo-10)/(2262+16) ; A4
defb 55,(10000000/tempo-10)/(2110+16) ; A4S
defb 52,(10000000/tempo-10)/(1996+16) ; B4
defb 49,(10000000/tempo-10)/(1882+16) ; C5
defb 46,(10000000/tempo-10)/(1768+16) ; C5S
defb 44,(10000000/tempo-10)/(1692+16) ; D5
defb 41,(10000000/tempo-10)/(1578+16) ; D5S
defb 39,(10000000/tempo-10)/(1502+16) ; E5
defb 37,(10000000/tempo-10)/(1426+16) ; F5
